## openmodelica 1.9.7~5-g64a2d09

=== debian/changelog ===
openmodelica (1.9.7~5-g64a2d09-1) unstable; urgency=low

  * Automatic git build
 -- OpenModelica Build System <build@openmodelica.org>  Fri, 19 Mar 2021 10:02:21 -0000
